#!/usr/local/bin/pgoblin -f
  Copyright (C)2019..2020 @BABOLO http://www.babolo.ru/
--PKG = mini-cipa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: set.pgoblin.m4,v 1.74 2022/04/23 19:05:35 babolo Exp $

#perform 0001  @@@@@@@@@@@@@===================================    - , ,   ====
CREATE TEMP TABLE x
     ( b text    --    (PROTOVER)  'minicipa'
     , u text    --    (${USER})
     , a text    --    (PROTOVER)
     )
;
#perform 0001
INSERT INTO x
 SELECT COALESCE( (SELECT a FROM a WHERE i = 0 AND regexp('^[a-z0-9_]+$', a))
                , 'minicipa'
                )
      , (SELECT e FROM e WHERE n = 'USER' AND regexp('^[a-z0-9_]+$', e))
      , (SELECT a FROM a WHERE i = 0 AND regexp('^[a-z0-9_]+$', a))
;
#connect 000T
pgsql dbname=template1 requirepeer=postgres application_name=minicipa
#select  b001  #################################################################  b - ${PROTOVER}  ####
SELECT b FROM x;
#select  u001  #####################################################################  u - ${USER}  ####
SELECT u FROM x;
#select  10bT  #####################################################  CREATE DATABASE ${PROTOVER}  ####
SELECT 'CREATE DATABASE ' || x.b || ';
'FROM (SELECT $1::text AS b)x
  LEFT JOIN pg_catalog.pg_database ON(x.b = pg_database.datname::text)
 WHERE pg_database.datname IS NULL
;
#perform 010T
#select  10uT  ####################################  CREATE ROLE ${USER}, root WITH LOGIN INHERIT  ####
SELECT 'CREATE ROLE ' || r || ' WITH LOGIN INHERIT;
'FROM  (SELECT $1::text AS r
       UNION
        SELECT 'root' AS r
       )r
  LEFT JOIN pg_catalog.pg_roles ON(r.r = pg_roles.rolname::text)
 WHERE pg_roles.rolname IS NULL
;
#perform 010T
#select  100T  #################################  CREATE ROLE cipa, operator WITH NOLOGIN INHERIT  ####
SELECT 'CREATE ROLE ' || r || ' WITH NOLOGIN INHERIT;
'FROM  (SELECT 'cipa' AS r
       UNION
        SELECT 'operator' AS r
       )r
  LEFT JOIN pg_catalog.pg_roles ON(r.r = pg_roles.rolname::text)
 WHERE pg_roles.rolname IS NULL
;
#perform 010T
#select  10bT  ######################################  CREATE ROLE ${PROTOVER} WITH LOGIN INHERIT  ####
SELECT 'CREATE ROLE ' || r || ' WITH LOGIN INHERIT;
'FROM  (SELECT $1::text AS r)r
  LEFT JOIN pg_catalog.pg_roles ON(r.r = pg_roles.rolname::text)
 WHERE pg_roles.rolname IS NULL
;
#perform 010T
#select  10u1  #######################################################  GRANT operator TO ${USER}  ####
SELECT 'GRANT operator TO ' || ? || ';';
#perform 010T
#perform 000T  ####################################################  GRANT cipa TO root, operator  ####
GRANT cipa TO root, operator;
#select  10b1  ##########################  GRANT CONNECT ON DATABASE ${PROTOVER} TO root, ${USER}  ####
SELECT 'GRANT CONNECT ON DATABASE ' || ? || ' TO root, ' || quote_ident(x.u) || ';
'FROM x
;
#perform 010T
#select  10b1  ############################  GRANT TEMP ON DATABASE ${PROTOVER} TO root, operator  ####
SELECT 'GRANT TEMP ON DATABASE ' || ? || ' TO root, operator;
'
;
#perform 010T
#perform 0001  #######################################################      ####
CREATE TEMP TABLE v(v numeric);
#select  1001
SELECT 'PREFIX/include/babolo/PKG' || COALESCE(':' || a, '') || '.VERSION' FROM x;
#cat     V1
#trap
#echo
@@@Ignore it

#perform 0001
INSERT INTO v VALUES(VERS);
#return
#copyin  00V1
COPY v;
#untrap
#close   V0VT
#select  10b1  #########################################################     ####
SELECT 'pgsql dbname=' || ? || ' requirepeer=postgres application_name=minicipa';
#connect 0102
#trap
#echo
@@@Ignore it


#return
#begin   0002  ################
#select  1002
SELECT 'DROP EXTENSION IF EXISTS babolo_pglib CASCADE;
'FROM pg_available_extension_versions
 WHERE name = 'babolo_pglib' AND version::float < 2.00 AND installed
;
#perform 0102
#perform 0002
CREATE EXTENSION IF NOT EXISTS babolo_pglib;
#perform 0002
ALTER EXTENSION babolo_pglib UPDATE;
#end     0002  ################
#untrap
